/*
 * Copyright (C) 2015 Inteno Broadband Technology AB. All rights reserved.
 *
 * Author: Martin K. Schröder <mkschreder.uk@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */

JUCI.app
.directive("uciFirewallNatRuleEdit", function(){
	return {
		templateUrl: "/widgets/uci.firewall.nat.rule.edit.html", 
		scope: {
			rule: "=ngModel"
		}, 
		controller: "uciFirewallNatRuleEdit", 
		replace: true
	};  
}).controller("uciFirewallNatRuleEdit", function($scope, $uci, $rpc, $firewall, $network){
	$scope.portIsRange = 0;
	$scope.data = {}; 
	$scope.$watch("rule", function(value){
		if(!value) return;
		if(!value[".config"]) { 
			console.error("nat-rule-edit: invalid ngModel! must be config section! "+Object.keys(value)); 
			return; 
		}
		$scope.data.src_ip_enabled = (value.src_ip.value)?true:false; 
	}); 
	$scope.$watch("data.src_ip_enabled", function(value){
		if($scope.rule && value == false) $scope.rule.src_ip.value = ""; 
	}); 

	$scope.protocolChoices = [
		{ label: "UDP", value: "udp"}, 
		{ label: "TCP", value: "tcp"}, 
		{ label: "TCP + UDP", value: "tcpudp" }
	]; 
	$scope.deviceChoices = [];
	$firewall.getZones().done(function(zones){
		$scope.allZones = zones.map(function(x){ return { label: x.name.value.toUpperCase(), value: x.name.value } }); 
		$network.getConnectedClients().done(function(clients){
			var choices = []; 
			clients.map(function(c) {
				choices.push({
					label: (c.hostname && c.hostname.length)?c.hostname:c.ipaddr, 
					value: c.ipaddr
				}); 
			}); 
			$scope.deviceChoices = choices; 
			$scope.$apply(); 
		});
	}); 
	$scope.onPortRangeClick = function(value){
		$scope.portIsRange = value;  
	}
}); 
