/*
 * Copyright (C) 2015 Inteno Broadband Technology AB. All rights reserved.
 *
 * Author: Martin K. Schröder <mkschreder.uk@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */

JUCI.app
.factory("networkConnectionPicker", function($modal, $network){
	return {
		show: function(opts){
			var def = $.Deferred();
			var exclude = {}; // allready added nets that will be excluded from the list
			if(!opts) opts = {};
			if(opts.exclude && opts.exclude instanceof Array) opts.exclude.map(function(x){ exclude[x[".name"]] = true; });
			$network.getNetworks().done(function(nets){
				var modalInstance = $modal.open({
					animation: true,
					templateUrl: 'widgets/network-connection-picker.html',
					controller: 'networkConnectionPickerModal',
					resolve: {
						nets: function () {
							return nets.filter(function(x) { return x[".name"] != "loopback" && !(x[".name"] in exclude); }).map(function(net){
								return { label: net[".name"], value: net[".name"] };
							});
						}
					}
				});

				modalInstance.result.then(function (data) {
					setTimeout(function(){ // do this because the callback is called during $apply() cycle
						def.resolve(nets.find(function(x){ return x[".name"] == data; }));
					}, 0);
				}, function () {
					console.log('Modal dismissed at: ' + new Date());
				});
			});
			return def.promise();
		}
	};
})
.controller("networkConnectionPickerModal", function($scope, $modalInstance, $wireless, nets, $tr, gettext){
	$scope.networks = nets;
	$scope.data = {};
  $scope.ok = function () {
		if(!$scope.data.selected) {
			alert($tr(gettext("You need to select a network!")));
			return;
		}
		$modalInstance.close($scope.data.selected);
  };

  $scope.cancel = function () {
    $modalInstance.dismiss('cancel');
  };
})
