/*
 * Copyright (C) 2015 Inteno Broadband Technology AB. All rights reserved.
 *
 * Author: Martin K. Schröder <mkschreder.uk@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */

JUCI.app
.directive("networkConnectionProtoWwanEdit", function(){
	return {
		scope: {
			interface: "=ngModel"
		},
		templateUrl: "/widgets/proto/network-connection-proto-wwan-edit.html",
		controller: "networkConnectionProtoWwanEditCtrl",
		replace: true
	};
}).controller("networkConnectionProtoWwanEditCtrl", function($scope, $tr, gettext, $rpc, $network){
	$network.getAdapters().done(function(adapters){
		$scope.devices = adapters.filter(function(ad){ return ad.is_usb; }).map(function(usb){
			return { label: usb.name, value: usb.device };
		});
		$scope.$apply();
	}).fail(function(e){console.log(e);});
	$scope.authtypes = [
		{ label: $tr(gettext("PAP")), value: "pap" },
		{ label: $tr(gettext("CHAP")), value: "chap" },
		{ label: $tr(gettext("Both")), value: "both" },
		{ label: $tr(gettext("None")), value: "" }
	];
});
